// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_sensor_msgs:msg/WheelEncoder.idl
// generated code does not contain a copyright notice
#include "marti_sensor_msgs/msg/detail/wheel_encoder__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
marti_sensor_msgs__msg__WheelEncoder__init(marti_sensor_msgs__msg__WheelEncoder * msg)
{
  if (!msg) {
    return false;
  }
  // frequency
  // directional
  // id
  return true;
}

void
marti_sensor_msgs__msg__WheelEncoder__fini(marti_sensor_msgs__msg__WheelEncoder * msg)
{
  if (!msg) {
    return;
  }
  // frequency
  // directional
  // id
}

bool
marti_sensor_msgs__msg__WheelEncoder__are_equal(const marti_sensor_msgs__msg__WheelEncoder * lhs, const marti_sensor_msgs__msg__WheelEncoder * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // frequency
  if (lhs->frequency != rhs->frequency) {
    return false;
  }
  // directional
  if (lhs->directional != rhs->directional) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  return true;
}

bool
marti_sensor_msgs__msg__WheelEncoder__copy(
  const marti_sensor_msgs__msg__WheelEncoder * input,
  marti_sensor_msgs__msg__WheelEncoder * output)
{
  if (!input || !output) {
    return false;
  }
  // frequency
  output->frequency = input->frequency;
  // directional
  output->directional = input->directional;
  // id
  output->id = input->id;
  return true;
}

marti_sensor_msgs__msg__WheelEncoder *
marti_sensor_msgs__msg__WheelEncoder__create()
{
  marti_sensor_msgs__msg__WheelEncoder * msg = (marti_sensor_msgs__msg__WheelEncoder *)malloc(sizeof(marti_sensor_msgs__msg__WheelEncoder));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_sensor_msgs__msg__WheelEncoder));
  bool success = marti_sensor_msgs__msg__WheelEncoder__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_sensor_msgs__msg__WheelEncoder__destroy(marti_sensor_msgs__msg__WheelEncoder * msg)
{
  if (msg) {
    marti_sensor_msgs__msg__WheelEncoder__fini(msg);
  }
  free(msg);
}


bool
marti_sensor_msgs__msg__WheelEncoder__Sequence__init(marti_sensor_msgs__msg__WheelEncoder__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_sensor_msgs__msg__WheelEncoder * data = NULL;
  if (size) {
    data = (marti_sensor_msgs__msg__WheelEncoder *)calloc(size, sizeof(marti_sensor_msgs__msg__WheelEncoder));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_sensor_msgs__msg__WheelEncoder__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_sensor_msgs__msg__WheelEncoder__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_sensor_msgs__msg__WheelEncoder__Sequence__fini(marti_sensor_msgs__msg__WheelEncoder__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_sensor_msgs__msg__WheelEncoder__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_sensor_msgs__msg__WheelEncoder__Sequence *
marti_sensor_msgs__msg__WheelEncoder__Sequence__create(size_t size)
{
  marti_sensor_msgs__msg__WheelEncoder__Sequence * array = (marti_sensor_msgs__msg__WheelEncoder__Sequence *)malloc(sizeof(marti_sensor_msgs__msg__WheelEncoder__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_sensor_msgs__msg__WheelEncoder__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_sensor_msgs__msg__WheelEncoder__Sequence__destroy(marti_sensor_msgs__msg__WheelEncoder__Sequence * array)
{
  if (array) {
    marti_sensor_msgs__msg__WheelEncoder__Sequence__fini(array);
  }
  free(array);
}

bool
marti_sensor_msgs__msg__WheelEncoder__Sequence__are_equal(const marti_sensor_msgs__msg__WheelEncoder__Sequence * lhs, const marti_sensor_msgs__msg__WheelEncoder__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_sensor_msgs__msg__WheelEncoder__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_sensor_msgs__msg__WheelEncoder__Sequence__copy(
  const marti_sensor_msgs__msg__WheelEncoder__Sequence * input,
  marti_sensor_msgs__msg__WheelEncoder__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_sensor_msgs__msg__WheelEncoder);
    marti_sensor_msgs__msg__WheelEncoder * data =
      (marti_sensor_msgs__msg__WheelEncoder *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_sensor_msgs__msg__WheelEncoder__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          marti_sensor_msgs__msg__WheelEncoder__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_sensor_msgs__msg__WheelEncoder__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
